#include "init.h"

//------------------------------------------------------------------------------
void hw_init () {
    
    WDTCONbits.WDTPS = 2;
	OSCCONbits.IRCF = 0b111; //internal oscillator 8MHz
	ANSEL = 0;	//all pins digital
	ANSELH = 0; //all pins digital
	ADCON0bits.ADON = 0; //disconnect analog inputs
    // --------- INP ----------
	//IR receiver
	TRISAbits.TRISA2 = 1; //IR input with External interrupt
    //uSwitch input
    OPTION_REGbits.nRABPU = 0; //PORTA/PORTB pull-ups are enabled by individual port latch values
	TRISAbits.TRISA4 = 1; //RA4 as input
    WPUAbits.WPU4 = 1; //RA4 weak pull-up
    //pin change-on
    IOCAbits.IOCA2 = 1;
    INTCONbits.RABIE = ON;
    // --------- OUT -----------
    //Multiplexer
    TRISB = 0; //S0
    //LED Display
    TRISC = 0;
	PORTA = 0; //
	PORTB = 0;
	PORTC = 0;
    PORTBbits.RB5 = 1;
    PORTBbits.RB6 = 1;
    PORTBbits.RB4 = 0;
    //--------------------------------------------------------------------
    //timer0 configuration
    OPTION_REGbits.T0CS = 0; 
    OPTION_REGbits.PSA = 0;
    OPTION_REGbits.PS0 = 0; 
    OPTION_REGbits.PS1 = 1;
    OPTION_REGbits.PS2 = 1;
    INTCONbits.T0IE = ON; //off
    //--------------------------------------------------------------------
	//timer1 16bits
	INTCONbits.PEIE = ON; //peripherial
	PIR1bits.TMR1IF = OFF;
	PIE1bits.TMR1IE = ON; //TMR1 Overflow Interrupt Enable bit
	T1CONbits.T1CKPS = 0b00;
	T1CONbits.TMR1ON = ON; //timer on	
    //--------------------------------------------------------------------
    //timer2 
    T2CONbits.T2CKPS = 0; //prescaler 4x
    T2CONbits.TOUTPS = 0; //postscaler 2x
    PR2 = 0xFF; //period register
    PIE1bits.TMR2IE = ON; //enable T2ovf interrupt
    T2CONbits.TMR2ON = ON; //TMR2 ON
	INTCONbits.GIE = ON; 
    
}
//------------------------------------------------------------------------------
void sw_init () {
    main_sm.current_channel = ee_record.current_channel;
    if(main_sm.current_channel >= NO_CHANNELS) {
        main_sm.current_channel = main_sm.current_channel = 0;
    }
    
    main_sm.sleep_timer_step = ee_record.auto_sleep_mode;
    if(main_sm.sleep_timer_step != 1) {
        main_sm.sleep_timer_step = 0;
    }
    main_sm.mute_timer = MUTE_TIMER_MAX;
    main_sm.tpulse = 0;
    main_sm.ir_pulse_received = 0;
    main_sm.sleep_timer = SLEEP_EVENT_START;
    main_sm.frame_cnt = FRAME_CNT_LVL;

    init_led();
    init_switch();
    init_menu();
    initsm();
}
//------------------------------------------------------------------------------