/*
 * Infra Red protocols decoder
 * Author: Piotr Wjtowicz
 * 2016-2017
 * pw@elportal.pl
 */

#include "necdec.h"
// -----------------------------------------------
void necPreLstate() {
    TROUT3 (
        TR(NEC_PREAMBLE_LOW, NEC_EPS, 1, necH1state),
        RET1, RET0
    );
}
// -----------------------------------------------

void necL1state() {
    TROUT4 (
        TR(NEC_BIT_LOW, NEC_EPS, 1, necH1state),
        TR(NEC_BIT_HI, NEC_EPS, 1, necH2state),
        RET1, RET0
    );
    sm.productReady = 1;
}
// -----------------------------------------------
static void necHstate(uint8_t productBitVal) {
    TROUT3 (
        TR(NEC_BIT_LOW, NEC_EPS, 0, necL1state),
        RET0, RET1
    );
    if (sm.productReady) {
        necAddBit(productBitVal);
        sm.productReady = 0;
    }
}
// -----------------------------------------------
void necH1state() {
    necHstate(0);
}
// -----------------------------------------------
void necH2state() {
    necHstate(1);
}
// -----------------------------------------------
void necAddBit(uint8_t bitValue) {
    irsm.data[irsm.field] >>= 1;
    irsm.data[irsm.field] |= bitValue<<7;

    if(irsm.bitCounter>=7) {
        irsm.field++;
        irsm.bitCounter = 0;
    } else {
        irsm.bitCounter++;
    }

    if (irsm.field>3) {
        //TODO: check if extend NEC protocol
//        if(irsm.data[0] != (uint8_t)(~irsm.data[1]) &&
//            ((uint8_t)(~irsm.data[0]) & 0b10111111) != irsm.data[1]) {
//            return;
//        }
        if(irsm.data[2] != (uint8_t)(~irsm.data[3])) {
            return;
        }

        frame_ret.pt = NEC;
        frame_ret.addr = irsm.data[0];
        frame_ret.cmd = irsm.data[2];
    }

}
// -----------------------------------------------

